      SUBROUTINE AER3R(NM,N,MBW,A,E21,M,W,Z,IERR,NV,RV,RV6)
      DIMENSION A(NM,MBW),W(M),Z(NM,M),RV(NV),RV6(N)
      INTEGER NM,N,MBW,M,IERR,NV,I,J,K,R,II,IJ,JJ,KJ,MB,M1,
     1IJ1,ITS,KJ1,M21,MAXJ,MAXK,GROUP,MIN0
      REAL A,E21,W,Z,RV,RV6,U,V,UK,XU,X0,X1,EPS2,EPS3,EPS4,
     1NORM,ORDER,MACHEP,SYS051,SQRT,ABS,FLOAT,SIGN
      DATA  SYS051/1.192093E-07/
      MACHEP=SYS051
      IERR=0
      IF(M.EQ.0) GO TO 37
      MB=MBW
      IF(E21.LT.0.0) MB=(MBW+1)/2
      M1=MB-1
      M21=M1+MB
      ORDER=1.0-ABS(E21)
C **********
      DO 36 R=1,M
      ITS=1
      X1=W(R)
      IF(R.NE.1) GO TO 4
C **********
      NORM=0.0
      DO 2 J=1,MB
      JJ=MB+1-J
      KJ=JJ+M1
      IJ=1
      DO 1 I=JJ,N
      NORM=NORM+ABS(A(I,J))
      IF(E21.GE.0.0) GO TO 1
      NORM=NORM+ABS(A(IJ,KJ))
      IJ=IJ+1
    1 CONTINUE
    2 CONTINUE
      IF(E21.LT.0.0) NORM=0.5*NORM
C **********
      IF(NORM.EQ.0.0) NORM=1.0
      EPS2=1.0E-3*NORM*ABS(ORDER)
      EPS3=MACHEP*NORM
      UK=SQRT(FLOAT(N))
      EPS4=UK*EPS3
    3 GROUP=0
      GO TO 5
C *********
    4 IF(ABS(X1-X0).GE.EPS2) GO TO 3
      GROUP=GROUP+1
      IF(ORDER*(X1-X0).LE.0.0) X1=X0+ORDER*EPS3
C **********
    5 DO 11 I=1,N
      IJ=I+MIN0(0,I-M1)*N
      KJ=IJ+MB*N
      IJ1=KJ+M1*N
      IF(M1.EQ.0) GO TO 10
      DO 9 J=1,M1
      IF(IJ.GT.M1) GO TO 6
      IF(IJ.GT.0) GO TO 7
      RV(IJ1)=0.0
      IJ1=IJ1+N
      GO TO 7
    6 RV(IJ)=A(I,J)
    7 IJ=IJ+N
      II=I+J
      IF(II.GT.N) GO TO 9
      JJ=MB-J
      IF(E21.GE.0.0) GO TO 8
      II=I
      JJ=MB+J
    8 RV(KJ)=A(II,JJ)
      KJ=KJ+N
    9 CONTINUE
   10 RV(IJ)=A(I,MB)-X1
      RV6(I)=EPS4
      IF(ORDER.EQ.0.0) RV6(I)=Z(I,R)
   11 CONTINUE
      IF(M1.EQ.0) GO TO 20
C **********
      DO 19 I=1,N
      II=I+1
      MAXK=MIN0(I+M1-1,N)
      MAXJ=MIN0(N-I,M21-2)*N
      DO 13 K=I,MAXK
      KJ1=K
      J=KJ1+N
      JJ=J+MAXJ
      DO 12 KJ=J,JJ,N
      RV(KJ1)=RV(KJ)
      KJ1=KJ
   12 CONTINUE
      RV(KJ1)=0.0
   13 CONTINUE
      IF(I.EQ.N) GO TO 19
      U=0.0
      MAXK=MIN0(I+M1,N)
      MAXJ=MIN0(N-II,M21-2)*N
      DO 14 J=I,MAXK
      IF(ABS(RV(J)).LT.ABS(U)) GO TO 14
      U=RV(J)
      K=J
   14 CONTINUE
      J=I+N
      JJ=J+MAXJ
      IF(K.EQ.I) GO TO 16
      KJ=K
      DO 15 IJ=I,JJ,N
      V=RV(IJ)
      RV(IJ)=RV(KJ)
      RV(KJ)=V
      KJ=KJ+N
   15 CONTINUE
      IF(ORDER.NE.0.0) GO TO 16
      V=RV6(I)
      RV6(I)=RV6(K)
      RV6(K)=V
   16 IF(U.EQ.0.0) GO TO 19
      DO 18 K=II,MAXK
      V=RV(K)/U
      KJ=K
      DO 17 IJ=J,JJ,N
      KJ=KJ+N
      RV(KJ)=RV(KJ)-V*RV(IJ)
   17 CONTINUE
      IF(ORDER.EQ.0.0) RV6(K)=RV6(K)-V*RV6(I)
   18 CONTINUE
   19 CONTINUE
C **********
   20 DO 24 II=1,N
      I=N+1-II
      MAXJ=MIN0(II,M21)
      IF(MAXJ.EQ.1) GO TO 22
      IJ1=I
      J=IJ1+N
      JJ=J+(MAXJ-2)*N
      DO 21 IJ=J,JJ,N
      IJ1=IJ1+1
      RV6(I)=RV6(I)-RV(IJ)*RV6(IJ1)
   21 CONTINUE
   22 V=RV(I)
      IF(ABS(V).GE.EPS3) GO TO 23
C **********
      IF(ORDER.EQ.0.0) IERR=-R
      V=SIGN(EPS3,V)
   23 RV6(I)=RV6(I)/V
   24 CONTINUE
      XU=1.0
      IF(ORDER.EQ.0.0) GO TO 34
C **********
      IF(GROUP.EQ.0) GO TO 28
      DO 27 JJ=1,GROUP
      J=R-GROUP-1+JJ
      XU=0.0
      DO 25 I=1,N
   25 XU=XU+RV6(I)*Z(I,J)
      DO 26 I=1,N
   26 RV6(I)=RV6(I)-XU*Z(I,J)
   27 CONTINUE
   28 NORM=0.0
      DO 29 I=1,N
   29 NORM=NORM+ABS(RV6(I))
      IF(NORM.GE.1.0E-1) GO TO 32
C **********
      IF(ITS.GE.N) GO TO 31
      ITS=ITS+1
      XU=EPS4/(UK+1.0)
      RV6(1)=EPS4
      DO 30 I=2,N
   30 RV6(I)=XU
      RV6(ITS)=RV6(ITS)-EPS4*UK
      GO TO 20
C **********
   31 IERR=-R
      XU=0.0
      GO TO 34
C **********
   32 U=0.0
      DO 33 I=1,N
   33 U=U+RV6(I)**2
      XU=1.0/SQRT(U)
   34 DO 35 I=1,N
   35 Z(I,R)=RV6(I)*XU
      X0=X1
   36 CONTINUE
   37 RETURN
      END
